#include "mpi.h"
#define MAX_N 1000
#define ROOT 0

int produto_escalar(int x[], int y[], int k) {
  int i, pe = 0;
  for (i = 0; i < k; i++)
    pe = pe + x[i] * y[i];
  return pe;
}

main(int argc, char **argv) {
  int i, my_rank, n_procs;
  int vector_x[MAX_N], vector_y[MAX_N];
  int N, K, pe, loc_pe, *loc_x, *loc_y;

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
  MPI_Comm_size(MPI_COMM_WORLD, &n_procs);

  // iniciar N, K e os vectores X e Y
  if (my_rank == ROOT) {
    K = 10;
    N = K * n_procs;    
    for (i = 0; i < N; i++) {
      vector_x[i] = i;
      vector_y[i] = N - 1 - i;
    }
  }
  // enviar K a todos os processos
  MPI_Bcast(&K, 1, MPI_INT, ROOT, MPI_COMM_WORLD);
  // alocar espao para os vectores locais
  loc_x = (int *) malloc(K * sizeof(int));
  loc_y = (int *) malloc(K * sizeof(int));
  // distribuir as componentes dos vectores X e Y
  MPI_Scatter(vector_x, K, MPI_INT, loc_x, K, MPI_INT, ROOT, MPI_COMM_WORLD); 
  MPI_Scatter(vector_y, K, MPI_INT, loc_y, K, MPI_INT, ROOT, MPI_COMM_WORLD); 
  // calcular o produto escalar
  loc_pe = produto_escalar(loc_x, loc_y, K);
  MPI_Reduce(&loc_pe, &pe, 1, MPI_INT, MPI_SUM, ROOT,MPI_COMM_WORLD);
  // apresentar o resultado
  if (my_rank == ROOT)
    printf("Produto Escalar = %d\n", pe);

  MPI_Finalize();
}

