#include "mpi.h"
#define STD_TAG 0
#define BUF_SIZE 1000

main(int argc, char **argv) {
  int i, j, my_rank, n_procs, position;
  int *my_matrix, ROWS, COLS;
  char pack_buf[BUF_SIZE];

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
  MPI_Comm_size(MPI_COMM_WORLD, &n_procs);
  if (n_procs != 2) {
    MPI_Finalize();
    if (my_rank == 0)
      printf("Execute o programa com 2 processos!\n");
    exit(0);
  }

  if (my_rank == 0) {
    // suponha que os valores de ROWS e COLS no so 
    // do conhecimento do processo 1 (so variveis)
    ROWS = 3;
    COLS = 5;
    my_matrix = (int *) malloc(ROWS * COLS * sizeof(int));
    // iniciar my_matrix
    for (i = 0; i < ROWS; i++)
      for (j = 0; j < COLS; j++)
	my_matrix[i * COLS + j] = i + j;
    // empacotar ROWS, COLS e my_matrix
    position = 0;
    MPI_Pack(&ROWS, 1, MPI_INT, pack_buf, BUF_SIZE, &position, MPI_COMM_WORLD);
    MPI_Pack(&COLS, 1, MPI_INT, pack_buf, BUF_SIZE, &position, MPI_COMM_WORLD);
    MPI_Pack(my_matrix, ROWS * COLS, MPI_INT, pack_buf, BUF_SIZE, &position, MPI_COMM_WORLD);
    // enviar pacote de dados
    MPI_Send(pack_buf, position, MPI_PACKED, 1, STD_TAG, MPI_COMM_WORLD);
  } else {
    // receber pacote de dados
    MPI_Recv(&pack_buf, BUF_SIZE, MPI_PACKED, 0, STD_TAG, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
    // desempacotar ROWS, COLS e my_matrix
    position = 0;
    MPI_Unpack(&pack_buf, BUF_SIZE, &position, &ROWS, 1, MPI_INT, MPI_COMM_WORLD);
    MPI_Unpack(&pack_buf, BUF_SIZE, &position, &COLS, 1, MPI_INT, MPI_COMM_WORLD);
    my_matrix = (int *) malloc(ROWS * COLS * sizeof(int));
    MPI_Unpack(&pack_buf, BUF_SIZE, &position, my_matrix, ROWS * COLS, MPI_INT, MPI_COMM_WORLD);
    // apresentar os dados recebidos
    printf("ROWS: %d - COLS: %d\nMatriz:\n", ROWS, COLS);
    for (i = 0; i < ROWS; i++) {
      for (j = 0; j < COLS; j++)
	printf("%d ", my_matrix[i * COLS + j]);
      printf("\n");
    }
  }

  MPI_Finalize();
}
