#include "mpi.h"
#define ROOT 0

int produto_escalar(int x[], int y[], int k) {
  int i, pe = 0;
  for (i = 0; i < k; i++)
    pe = pe + x[i] * y[i];
  return pe;
}

main(int argc, char **argv) {
  int i, j, my_rank, n_procs;
  int ROWS, COLS, *matrix, *vector, *result;
  int pe, *linha;

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
  MPI_Comm_size(MPI_COMM_WORLD, &n_procs);

  // iniciar ROWS, COLS e o vector
  ROWS = n_procs;
  COLS = 3;
  vector = (int *) malloc(COLS * sizeof(int));
  linha = (int *) malloc(COLS * sizeof(int));
  for (i = 0; i < COLS; i++)
    vector[i] = i;
  // iniciar a matriz
  if (my_rank == ROOT) {
    result = (int *) malloc(ROWS * sizeof(int));
    matrix = (int *) malloc(ROWS * COLS * sizeof(int));
    for (i = 0; i < ROWS; i++)
      for (j = 0; j < COLS; j++)
	matrix[i * COLS + j] = i + j;
  }
  // distribuir a matriz
  MPI_Scatter(matrix, COLS, MPI_INT, linha, COLS, MPI_INT, ROOT, MPI_COMM_WORLD); 
  // calcular o produto matriz-vector
  pe = produto_escalar(linha, vector, COLS);
  MPI_Gather(&pe, 1, MPI_INT, result, 1, MPI_INT, ROOT, MPI_COMM_WORLD); 
  // apresentar o resultado
  if (my_rank == ROOT) {
    printf("Produto Matriz-Vector: ");
    for (i = 0; i < ROWS; i++)
      printf("%d ", result[i]);
    printf("\n");
  }

  MPI_Finalize();
}

